// Aqua_GPIO.cpp : Defines the entry point for the application.
//

#include "stdafx.h"
#include "gpio.h"
#include "Windev.h"

/*
	This is a gpio sample.
	You can use the following GPIOs:
		GPIO5	- GPIO1 on CAMI connector
		GPIO6	- GPIO0 on CAMI connector
		GPIO27	- GPIO2 on CAMI connector
		GPIO26	- GPIO3 on CAMI connector

		Shared:	
		GPIO1	- TIMER_OUT alternative function
		GPIO25	- PME alternative function		

	Before first use the IOCTL_GPIO_SET_RESET_STATE ioctl should be called, to reset the GPIO state.
*/

int WINAPI WinMain(	HINSTANCE hInstance,
					HINSTANCE hPrevInstance,
					LPTSTR    lpCmdLine,
					int       nCmdShow)
{
 	
	int iRet = TRUE;
	DWORD val,dw;

	HANDLE hFile = CreateFile (L"GIO1:", 0, 0, NULL, OPEN_ALWAYS, 0, NULL);
	if (hFile == INVALID_HANDLE_VALUE)
		return FALSE;

	// Init GPIOs

	val = 27; //Select GPIO
	iRet = DeviceIoControl (hFile, IOCTL_GPIO_SET_CURRENT, &val, 4, NULL, 0, NULL, NULL);
	val = GetLastError();

	iRet = DeviceIoControl (hFile, IOCTL_GPIO_SET_RESET_STATE, &val, 4, NULL, 0, NULL, NULL);

	while (1) {
		val = 0; //Write 1
		iRet = WriteFile(hFile, &val, 1, &dw, NULL);
		Sleep (1000);

		val = 1; //Write 1
		iRet = WriteFile(hFile, &val, 1, &dw, NULL);

		Sleep(1000);
	}


	CloseHandle (hFile);

	return 0;
}
